﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ClipboardChangeEvent
{
    public partial class Form1 : Form
    {
        private bool _pasteOperation = false;

        public Form1()
        {
            InitializeComponent();

            Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            fpSpread1.Change += FpSpread1_Change;
            fpSpread1.ActiveSheet.CellChanged += ActiveSheet_CellChanged;
            fpSpread1.ClipboardPasting += FpSpread1_ClipboardPasting;
        }

        private void FpSpread1_ClipboardPasting(object sender, FarPoint.Win.Spread.ClipboardPastingEventArgs e)
        {
            Console.WriteLine("FpSpread.ClipboardPasting");
            _pasteOperation = true;
        }

        private void ActiveSheet_CellChanged(object sender, FarPoint.Win.Spread.SheetViewEventArgs e)
        {
            if (_pasteOperation)
            {
                Console.WriteLine("ActiveSheet.CellChanged");

                // Do your Change operation here...

                _pasteOperation = false;
            }
        }

        private void FpSpread1_Change(object sender, FarPoint.Win.Spread.ChangeEventArgs e)
        {
            Console.WriteLine("FpSpread.Change");
        }
    }
}
